
/* :              Papandopala Papandopalavich
 *  :          Atmega16_LCD_LIB.c
 *  :			   Atmega16, Flash 16 Kbytes, SRAM 1 Kbytes, EEPROM 512 bytes.
 *  :   F_CPU 8000000 
 * :               28.06.2013 21:17:29
 *  :          ATMEL STUDIO VERSION 6.1.2562
 * FUSES:              HIGH xx, LOW xx;
 * :                LCD    HD44780 
					   .     4  8   
					   LCD,      */

#include <inttypes.h>

//---------------------------------------------------------------------------------------------
//    8   ,   #define LCD_8BIT
//#define LCD_8BIT
//---------------------------------------------------------------------------------------------

#ifndef LCD
#define LCD

#if 1

//       LCD DB0...DB7.
#define DPIN  PINC
#define DDDR  DDRC
#define DPORT PORTC

//       .						
//        LCD   
#define DB0	0// DB0
#define DB1	1// DB1
#define DB2	2// DB2	
#define DB3	3// DB3		
#define DB4	0// DB4  
#define DB5	1// DB5
#define DB6	2// DB6
#define DB7	3// DB7 + BF   .

//       E, RS, R/W.
#define CDDR  DDRB
#define CPORT PORTB

//    ,    .
#define E	0	// E	 .
#define RW	2   // R/W   R/W=1   LCD, R/W=0   LCD.
#define RS	1 	// RS	 RS=0    LCD, RS=1    LCD.

#endif
//---------------------------------- ---------------------------------
#if 1
// ,    .
                   
void LCDGotoXY(uint8_t,uint8_t);			             //   X, Y 
void LCDdata(uint8_t);						             // 1   .
void LCDdataXY(uint8_t,uint8_t,uint8_t);	             // 1     X, Y  .
void LCDsendString(char*);                             //   
void LCDstringXY(char*,uint8_t,uint8_t);		             //      x,y
void LCDstring_of_sramXY(uint8_t*,uint8_t,uint8_t);			 //      x,y  		
void LCDstring_of_flashXY(const uint8_t*,uint8_t, uint8_t);//    x,y  
void LCDDefSymb(const uint8_t *symb, uint8_t addr, uint8_t x, uint8_t y); //    CGRAM

void LCDinit(void);							// LCD  
void LCDblank(void);			//    
void LCDnblank(void);			//     +   .
void LCDclear(void);			//    +    0,0
void LCDcursor_bl(void);		//  
void LCDcursor_on(void);		//  
void LCDcursor_vi(void);		//  
void LCDcursorOFF(void);		//  ()
void LCDacr(void);				//C  AC     n+1
void LCDacl(void);				//C  AC     n-1
void LCDcursorl(void);			//    1 
void LCDcursorr(void);			//    1 
void LCDcursorln(uint8_t);		//    n 
void LCDcursorrn(uint8_t);		//    n 
void LCDscreenl(void);			//    1 
void LCDscreenr(void);			//    1 
void LCDscreenln(uint8_t);		//    n 
void LCDscreenrn(uint8_t);		//    n 
void LCDscreenL(void);			//       
void LCDscreenR(void);			//       
void LCDresshift(void);			//   0,0 +   ,  



// .
#define LINE0 0x00
#define LINE1 0x40

#endif

/*           */
#if 1
/*          
       */

#define BCD_SendData(data) //LCD_WriteData(data)

/*      .  , 
   */

#define MIRROR_NULL

/*   .  ,    
   */

#define BCD_USE_BUF

/*       - . 
,      - , 
        */

#define BCD_SYM

/***************************   ***********************/

/*   .    ,
    */

uint8_t* BCD_GetPointerBuf(void);

/* 8-   .    1, 2  3-
  .   BCD_1(uint8_t value)  2  3-
  ,    .    
    */

void BCD_1(uint8_t value);
void BCD_2(uint8_t value);
void BCD_3(uint8_t value);

/* 16-   .    3, 4  5-
  .   BCD_3Int(uint16_t value)  4  5-
  ,    .    
    */

void BCD_3Int(uint16_t value);
void BCD_4Int(uint16_t value);
void BCD_5Int(uint16_t value);

/*   8, 16  32   .  
     . */

void BCD_Uchar(uint8_t value);
void BCD_Uint(uint16_t value);
void BCD_Ulong(uint32_t value);

#endif

#endif

// 
/*
      .

1.      . 
    ,    .

//     lcd
#include "lcd_lib.h"

2.   .         .

//     
#define BCD_SendData(data)

// ,  
#define BCD_SendData(data) LCD_WriteData(data)

3.     .       , 
     .  ,   .

//   BCD_Uchar(3)    003
#define MIRROR_NULL

//  BCD_Uchar(3)    3
//#define MIRROR_NULL

4.  .
    ,         
  ,     -  .    
,       .

#define BCD_BUF_USE

5.   .       -  
  .      - ,  ,  .

#define BCD_SYM

 

    8, 16  32   .

void BCD_Uchar(uint8_t value) -    0  255
void BCD_Uint(uint16_t value) -    0  65535
void BCD_Ulong(uint32_t value) -    0  4294967295



#define F_CPU 9600000UL
...
uint8_t count = 120;
uint16_t adc_value = 1020;
...
BCD_Uchar(count);
BCD_Uint(adc_value);
BCD_Ulong(F_CPU);

      .

void BCD_1(uint8_t value) -    0  9
void BCD_2(uint8_t value) -    0  99
void BCD_3(uint8_t value) -    0  255
void BCD_3Int(uint16_t value) -    0  999
void BCD_4Int(uint16_t value) -    0  9999
void BCD_5Int(uint16_t value) -    0  65535



#define DATA 23
...
//   < 10
uint8_t index = 0;

//  999
uint8_t count;
...
BCD_1(index);
BCD_2(DATA);
BCD_3Int(count);

//  
BCD_1(DATA);
BCD_3(count);

     ,    .    ,    .

uint8_t* BCD_GetPointerBuf(void);


//    
uint8_t* pBuf;

//  
pBuf = BCD_GetPointerBuf();

// ,      
BCD_3Int(counter);
LCD_SendStr(pBuf);*/
//  
/*
LCDcommand(0b00101000);// 4   /   5x8 .
LCDcommand(0b00000001);// 
LCDcommand(0b00000010);//    0,0 +  
LCDcommand(0b00000110);//.   ,   .
LCDcommand(0b00001100);//    +   .

LCDdata('A');			//  
LCDGotoXY(6,1);			//      .
LCDdata('B');			//   
LCDdataXY('',0,0);      0,0
LCDdata('');
LCDdata('');
LCDdata('');
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LCDGotoXY(1,1);			    //    1,1.
LCDsendString("");//  
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
LCDstring(" ",0,1);//    0,1
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    uint8_t  text_1[]="_3";
LCDstring_of_sram(text_1,0,0);       0,0
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    const uint8_t PROGMEM text_1[]="_1";
LCDstring_of_flash(text_1,0,0);       0,0
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~							 						 
*/

/*
    .
1. .
2. VCC >=4.5V    15 .
3.  0x30 - 0b110000
4.   4.1 
5.  0x30
6.   100 
7.  0x30
      LCD
         .
8.      .

   =0, R/W=0, RS - , DB0...DB7   (HI).
    =0, R/W=0       
    .

  :

int main(void)
{
	init();		// .
	LCDinit();	// LCD,     ,   .

	while(1)//  .
	{
		
	}
}

  .
LCDGotoXY(3,1);
 3      .  0,       .
 1     0 .
|0,0|1,0|2,0|3,0|4,0|5,0|6,0|7,0| -  
|0,1|1,1|2,1|3,1|4,1|5,1|6,1|7,1| -  

1  0  0
1 I/D S  
I/D -   , 0- 1-
S   -    0   , 1 , 
       I/D - 0  ,  1  .
LCDcommand(100) -  n-1,   .     <-
LCDcommand(110) -  n+1,   .     ->
LCDcommand(101)	-  n-1,       
LCDcommand(111) -  n+1,       
	   	   
1   0   0   0  0	   
1  S/C R/L  -  -     
S/C (screen/cursor) - 0  , 1  .
R/L (right/left)    - 0  , 1  .     1 
*/